-- Button controls for Euphoria

include keys.e          -- key definitions
include graphics.e      -- colors
include wildcard.e      -- upper/lower
include control.e        -- color scheme

-----------------------------------------------------------------------------
global function draw_button( sequence button )

    integer titleAt

    -- shadow
    -- position( button[ROW], button[COL]+button[WIDE] )
    -- put_colors( {GRAY, OF_DIALOG[2]}, "" )

    --position( button[ROW]+1, button[COL]+1 )
    --put_colors( {GRAY, OF_DIALOG[2]}, repeat( '', button[WIDE] ) )

    -- blank button
    position( button[ROW], button[COL] )
    put_colors( OF_DIALOG_BUTTON, repeat(   ' ', button[WIDE] ) )

    -- calculate text's position
    titleAt = floor( ( button[WIDE] / 2 ) - 
                     ( length( button[TITLE] ) / 2 ) + button[COL] )
        
    -- add focus button is has focus
    if button[FOCUS] then
        position( button[ROW], button[COL] )
        put_colors( OF_DIALOG_BUTTON, { 221 } ) -- '>'
        --put_colors( OF_DIALOG_BUTTON, ">" )
        position( button[ROW], button[COL]+button[WIDE]-1 )
        put_colors( OF_DIALOG_BUTTON, { 222 } ) -- '<'
        --put_colors( OF_DIALOG_BUTTON, "<" )
    end if
        
    -- draw text
    position( button[ROW], titleAt )
    if button[DIM] then
        put_colors( { OF_DISABLED[1], OF_DIALOG_BUTTON[2] }, button[TITLE] )
    else
        put_colors( OF_DIALOG_BUTTON, button[TITLE] )
    end if

    -- hot key
    if button[HOT] > 0 and not button[DIM] then
        position( button[ROW], titleAt+button[HOT]-1 )
        put_colors( {OF_HOTKEY[1], OF_DIALOG_BUTTON[2]}, 
                    {button[TITLE][button[HOT]]} )
    end if

    -- position cursor
    position( button[ROW], titleAt )

    return button

end function

-----------------------------------------------------------------------------
global function draw_pushed_button( sequence button )
        
    -- draw a pushed button

    integer titleAt
    
    -- hide prior button
    position( button[ROW], button[COL] )
    put_colors( OF_DIALOG, repeat( ' ', button[WIDE]+1 ) )
    
    -- blank button
    position( button[ROW], button[COL]+1 )
    put_colors( OF_DIALOG_BUTTON, repeat( ' ', button[WIDE] ) )

    -- calculate text's position
    titleAt = floor( ( button[WIDE] / 2 ) - ( length( button[TITLE] ) / 2 ) ) + button[COL]
    
    -- draw text
    position( button[ROW], titleAt+1 )
    put_colors( OF_DIALOG_BUTTON, button[TITLE] )

    -- hide shadow
    position( button[ROW]+1, button[COL] )
    put_colors( OF_DIALOG, repeat( ' ', button[WIDE]+1 ) )

    -- position cursor
    position( button[ROW], titleAt+1 )
    
    return button

end function



-----------------------------------------------------------------------------
global function edit_button( sequence button, integer key )

    -- respond to events
    
    -- alias button
    
    -- respond to key
    if key = MOUSE_CLICK
    or key = MOUSE_DOUBLE then
    
        -- push it
        button = draw_pushed_button( button )
    
        -- wait for release
        while key != MOUSE_UP do
            key = get_safe_key()
        end while
    
    end if
            
    -- draw with/without focus
    button = draw_button( button )
    
    return button

end function

