-- Check boxes for Euphoria

include keys.e          -- key definitions
include graphics.e      -- colors
include wildcard.e      -- upper/lower
include control.e       -- color scheme

----------------------------------------------------------------------------
global function draw_check( sequence check )

    sequence colors

    -- calculate width
    if check[WIDE] = 0 then
        check[WIDE] = length( check[TITLE] ) + 4
    end if

    -- color scheme
    if check[DIM] then
        colors = { OF_DISABLED[1], OF_DIALOG[2] }
    else
        colors = OF_DIALOG
    end if

    -- location
    position( check[ROW], check[COL] )

    -- checked?
    if check[CHECKED] then
        put_colors( colors, "[X] ")
    else
        put_colors( colors, "[ ] " )
    end if    

    -- redraw?
    if check[REDRAW] then

        -- title
        put_colors( colors, check[TITLE] )

        -- hot key
        if check[HOT] > 0 and not check[DIM] then
            -- use color scheme: hotkey foreground, dialog background
            position( check[ROW], check[COL]+check[HOT]+3 )
            put_colors( { OF_HOTKEY[1], OF_DIALOG[2] }, 
                        { check[TITLE][check[HOT]]} )
        end if
        
    end if

    -- position cursor
    position( check[ROW], check[COL]+1 )
    
    -- clear flag
    check[REDRAW] = 0

    return check

end function

-----------------------------------------------------------------------------
global function edit_check( sequence check, integer key )

    -- toggle on the following events
    if key =  ' ' 
    or key = MOUSE_CLICK
    or key = MOUSE_DOUBLE then

            -- toggle state
            check[CHECKED] = not check[CHECKED]

    end if

    -- redisplay
    check = draw_check( check )

    -- return new state
    return check

end function

