-- Radio buttons for Euphoria

include keys.e          -- key definitions
include graphics.e      -- colors
include wildcard.e      -- upper/lower
include control.e       -- color scheme

----------------------------------------------------------------------------
global function draw_radio( sequence radio )

    sequence colors

    -- calculate width
    if radio[WIDE] = 0 then
        radio[WIDE] = length( radio[TITLE] ) + 4
    end if

    -- dimmed?
    if radio[DIM] then
        colors = { OF_DISABLED[1], OF_DIALOG[2] }
    else
        colors = OF_DIALOG
    end if

    -- location
    position( radio[ROW], radio[COL] )

    -- checked?
    if radio[CHECKED] then
        put_colors( colors, "(*) " )
    else
        put_colors( colors, "( ) " )
    end if

    -- need everything redrawn?
    if radio[REDRAW] then

        -- display title
        put_colors( colors, radio[TITLE] )

        -- hot key?
        if radio[HOT] > 0 and not radio[DIM] then
        
            -- use color scheme: hotkey foreground, dialog background
            colors = { OF_HOTKEY[1], OF_DIALOG[2] }

            -- display
            position( radio[ROW], radio[COL]+radio[HOT]+3 )
            put_colors( colors, { radio[TITLE][radio[HOT]] } )
        
        end if

    end if

    -- position cursor
    position( radio[ROW], radio[COL]+1 )
        
    -- clear redraw
    radio[REDRAW] = 0

    return radio
            
            
end function

-----------------------------------------------------------------------------
global function edit_radio( sequence radio, integer key )

    -- toggle on the following events
    if key =  ' ' 
    or key = MOUSE_CLICK
    or key = MOUSE_DOUBLE then

        -- set as checked
        radio[CHECKED] = 1

    end if

    -- redisplay
    radio = draw_radio( radio )

    -- return new state
    return radio

end function

